#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2005-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                 -*-  code ckecker Analysis  -*-                              #
#                                                                              #
#                                                                              #
################################################################################
#$Id: codeChecker.pl,v 1.33.4.7 2011/05/23 15:30:34 rfrance Exp $
################################################################################


sub codeChecker_cc #($)
{
	my $src=shift;
	print &PerlTranslate("codeChecker.pl", "%1: Code checking...\n", "%1 is the name of the file to be analized", $src);
	my ($d,$n,$e)=SplitFileName($src);
	my $deffile="atus_c.def";
	my $cppOpt="";
	if(LanguageOf($e) eq "CPP") {
		$deffile="atl.hpp";
		$cppOpt="-CPP";
		$MISRA_CONF=~s/\\/\//g;
		$MISRA_CONF=$ENV{'TESTRTDIR'}.$MISRA_DEFAULT_CPP_CONF if($MISRA_CONF=~m/$MISRA_DEFAULT_C_CONF$/);
	}
	my $opt;
	my $command="crccc \"$src\" \"$INTDIR/$n.xob\" $deffile atl.opp $cppOpt -RULE=\"$MISRA_CONF\"";
	$command.=" -silent=$CHECK_SILENT" if($CHECK_SILENT >= 0);
	$command.=" -checksysinclude" if($CHECK_SYS_INC);
	if(($FILEVERCMS) && ($FILEVERCMS ne '0'))
	{
		print &PerlTranslate("codeChecker.pl", "Check file's version\n", "");
		my $v=getFileVersion($src);
		$command.=" -fileversion=\"$v\"";
	}
	my @nocheckincl=@NOCHECK_DIR_INC;
	my @sysincl=split(/,/,$Ini{STD_INCLUDE});
	my @include_dir;
	my $found;
	foreach my $incl (@COMPLETE_INCLUDE_DIR_LIST){
		foreach (@sysincl){
			if($incl=~ m/^\Q$_\E.*$/){
				push(@nocheckincl,$incl);
				$found=1;
				LAST;
			} else {
				if(s/^\w\://){
					if($incl=~ m/^\Q$_\E.*$/){
						push(@nocheckincl,$incl);
						$found=1;
						LAST;
					}
				}
			}
		}
		push(@include_dir,$incl) unless($found);
		$found=0;
	}
	$opt=' -std_incl="'.join(',',@nocheckincl).'"' if(@nocheckincl);
	$opt.=' -incl="'.join(',',@include_dir).'"' if(@include_dir);
	
	$opt=~ s,([\\\/])",$1.",g;
	$command.=$opt;
	$command.=' -preinclude="'.join('","',@INCLUDED_FILES).'"' if(@INCLUDED_FILES);
	$command.=" -define=\"".join("\",\"",@GENERATION_CONDITION)."\"" if(@GENERATION_CONDITION);
	my $ret = SystemP($command);
	return "" if($ret);
	open ( LOG, ">>$LOGFILENAME" ) or die &PerlTranslate("codeChecker.pl", "Cannot open log file: %1\n", "%1 is the reason given by the Operating System", $!);
	print  LOG "XOB $INTDIR/$n.xob\n";
	close( LOG );
	return "$INTDIR/$n.xob";
}

sub codeChecker_link
{
        print &PerlTranslate("codeChecker.pl", "%1: Code checking report...\n", "%1 is the name of the file to be analized", $NAME);
	if($TDP_LANGUAGE eq "CPP") {
		$MISRA_CONF=~s/\\/\//g;
		$MISRA_CONF=$ENV{'TESTRTDIR'}.$MISRA_DEFAULT_CPP_CONF if($MISRA_CONF=~m/$MISRA_DEFAULT_C_CONF$/);
	}        
        my $check_script;
	if($NAME_CHECK_SCRIPT){ #customer checking the naming rule
		$check_script=$NAME_CHECK_SCRIPT;
		$check_script.=".pl" unless($NAME_CHECK_SCRIPT =~ /\.pl$/);
		unless($check_script =~ m/[\\\/]/) {# if there is no path
			unless(-f $check_script){   # and the file does not exist
				$check_script=$SCRIPTDIR.$check_script; # look for it into the scripts dir
			}
		}
		if(-f $check_script){
			my $command="crcld -xref=\"$OUTDIR/$NAME.pl\" \"".join("\" \"",@XOB)."\" -RULE=\"$MISRA_CONF\"";
			$command.= " -TEST" if($ATOMODE || $ATUMODE || $ATVMODE || $ATSMODE);
			my $ret = SystemP($command);

			require $check_script;
			my $nrxob=namingRuleCheck("$OUTDIR/$NAME.pl");
			push(@XOB,$nrxob) if($nrxob);
		}else{
			print &PerlTranslate("codeChecker.pl", "%1: Name checking script not found\n", "%1 is the name of the script", $check_script);
		}
	}
	my $command="crcld -crc=\"$OUTDIR/$NAME.crc\" \"".join("\" \"",@XOB)."\" -RULE=\"$MISRA_CONF\"";
	$command.= " -TEST" if($ATOMODE || $ATUMODE ||  $ATVMODE || $ATSMODE);
	my $ret = SystemP($command);
	if($ret) {
	     print &PerlTranslate("codeChecker.pl", "Code checking report generation failed.($ret)\n");
	     return "";
	}
	open ( LOG, ">>$LOGFILENAME" ) or die &PerlTranslate("codeChecker.pl", "Cannot open log file: %1\n", "%1 is the reason given by the Operating System", $!);
	print  LOG "CRC $OUTDIR/$NAME.crc\n";
	if (-s "$OUTDIR/$NAME.crc" > 10000000){
		my @files=SplitCRC("$OUTDIR/$NAME.crc");
		foreach(@files) {print  LOG "CRC $_\n";}
	}
	close( LOG );
	return "$OUTDIR/$NAME.crc";
}

sub SplitCRC
{
$infile=shift;
my @RES;
my $SUM=0;
my $BUF=1;
my $DETAIL=0;
my $detailFile="";
my ($indir,$sumFile,$e)=SplitFileName($infile);
    open(OUS,">$infile.tmp") || die &PerlTranslate("SplitCRC.pl", "unable to write the file %1.tmp. check permissions\n","",$infile);
    $SUM=1;
	if(open(IN,$infile)){
	    while(<IN>){
		if(/^<XROD:NODE name=\"([^\"]+)\".*sum=\"1\".*base=/){ 
			$detailFile=$1.'.crc';
			if(OU){
				print OU "</DOCUMENT>\n</APIDOC>\n</XROD>\n";
				close OU ;
			}
			open(OU,">$indir$detailFile") || die &PerlTranslate("SplitCRC.pl", "unable to write the file %1. check permissions\n","",$indir.$detailFile);
			push(@RES,$indir.$detailFile);
			print OU $header;
			$DETAIL=1;
			$SUM=1;
		}

		if((/^<XROD:NODE.+type="desactivated rules"/) && $DETAIL) { $SUM=1;$DETAIL=0;}
		if($DETAIL) {
			print OU ;
		} 
		if($BUF) {
			$buffer.=$_;
		}
		if($SUM) {
			if((/^<LINK TARGET=/) && $DETAIL) { $_="<LINK TARGET=\"xrdlink://$detailFile\" ><IMAGE NAME=\"reporter_link_16.xpm\"/>";}
			print OUS ;
		} 
		if((/^<\/TABLE>/) && $DETAIL) { $SUM=0; print OUS "</SECTION>\n</XROD:NODE>\n";}
	        if(/Copyright IBM Corp./) {
	        	$BUF=0; 
	        	$header=$buffer."</ROW>\n<ROW STYLE=\"Array Title\">\n<CELL COLSPAN=\"1\" ROWSPAN=\"0\" STYLE=\"Array Failed\"><LINK TARGET=\"xrdlink://";
	        	$header=$header.$sumFile.'.crc';
	        	$header=$header."\"><IMAGE NAME=\"reporter_link_16.xpm\"/>\n<TEXT>";
	        	$header=$header."Global Report: ".$sumFile.'.crc';
	        	$header=$header."</TEXT>\n</LINK>\n</CELL>\n</ROW>\n</TABLE>\n</SECTION>\n"; $buffer='';}
		
	    } close IN;
	} else {
		print &PerlTranslate("SplitCRC.pl", "unable to open the file %1\n","",$infile);
	}
    if(OU){
	print OU "</DOCUMENT>\n</APIDOC>\n</XROD>\n";
	close OU ;
    }
    close OUS;
    rename("$infile.tmp",$infile);
    return @RES;
}

1;
