##!perl -w
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2005-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################
#TestRTctc.exe perl launcher is located in bin and execute this perl sript which is located in the lib/scripts
#TestRTctc.pl open the envNode perl file given as the second parameter
################################################################################
#$Id: trtcc.pl,v 1.1.2.8 2011/04/01 21:06:01 rfrance Exp $
################################################################################

# useful for stdout/stderr direct viewing inside 'console' of studio window
# (better: we have stdout/stderr lines in right order and not stderr before stdout
use FileHandle ;

STDOUT->autoflush(1);
STDERR->autoflush(1);

## globals ############
$main::TestRTCC=1;
#######################
$main::SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
my $nodeSettings='envNode.pl';
$OUTDIR='.';
$INIFILE='tp.ini';
$STAGE='cp';
$LOGFILENAME='trtcc.log';
require $SCRIPTDIR ."BatchCCDefaults.pl";
$USE_CFLAGS_TP=1;
$TARGETDIR=$ENV{ATLTGT};
#
# trtcc -cond <envNnode.pl> <source> -I<path> -D<def> -o <INTDIR>/<notused> -- <CFLAGS> [-CPPFLAGS- <CPPFLAGS>] [-PPFLAGS- <PPFLAGS>]
#
#
my $onCompilerOptions=0;
while(@ARGV) {
    $_=shift(@ARGV);
    if($onCompilerOptions){
	if($_ eq "-CPPFLAGS-"){#separator cmd CPPFLAGS for prepro and compil
		$onCompilerOptions=2;
	} elsif($_ eq "-PPFLAGS-"){#separator cmd PPFLAGS for prepro only
		$onCompilerOptions=3;
	} else {
	    if($onCompilerOptions==1){
		$CFLAGS.=' '.$_;
	    } elsif($onCompilerOptions==2){
		$CPPFLAGS.=' '.$_;
	    } elsif($onCompilerOptions==3){
		$PPFLAGS.=' '.$_;
	    }
	}
    } else {
	if(/^\"?-I(.+)$/){
		my $p=$1;$p=~s/\"//g;
		push(@INCLUDE_DIR_LIST,$p);
	} elsif(/^\"?-D(.+)$/){
		my $p=$1;$p=~s/\"$// if(s/^\"//);
		push(@GENERATION_CONDITION,$p);
	} elsif($_ eq "--"){#separator cmd CFLAGS for compil only
		$onCompilerOptions=1;
	} elsif(/^-config/){
		$nodeSettings=shift(@ARGV);
		$nodeSettings=~s/\"//g;
		die "$nodeSettings not found. Unable to Launch command.\n" unless (-f $nodeSettings);
		require $nodeSettings;

	} elsif(/^-(o|rtrt_output)$/){
		$out_file=shift(@ARGV);
		$out_file=~s/\"//g;
	} elsif(/^-/){
		$CFLAGS.=' '.$_;
	} else {
		if($FILENAME eq ''){
			$FILENAME=$_ ;
		} else {
			$CFLAGS.=' '.$_;
		}
	}
    }
}
$ASMFLAGS=$CFLAGS; # for asm sources
require $main::SCRIPTDIR."Source.pl";
require $SCRIPTDIR . "metricC.pl";
$INTDIR=getdir($out_file)  if($INTDIR eq '');
$FILENAME=~s/^\".*\"$/$1/;

CheckIntDir();
CheckOutDir();
EnterInScript();
$OBJEXT=$Ini{OBJEXT} if($OBJEXT eq '');
open ( LOG, ">>$LOGFILENAME" ) or die &PerlTranslate("trtcc.pl", "Cannot open log file: %1\n", "%1 is the reason given by the Operating System", $!);
print LOG "DIR ",GetCurrentDir(),"\n";
close( LOG );

if($USE_CFLAGS_TP && ($TP_CCFLAGS eq '')){
print "PWD=",GetCurrentDir(),"\n";
    open ( EN, ">>$nodeSettings" ) or die &PerlTranslate("trtcc.pl", "Cannot write settings file: %1\n", "%1 is the reason given by the Operating System", $!);
     print EN "\$TP_CCFLAGS='",$CFLAGS," ';\n";
     print EN "\@COMPIL_INCLUDE_DIR=('".join("','",@INCLUDE_DIR_LIST)."');\n" if(@INCLUDE_DIR_LIST);
     print EN "\@COMPIL_DEFINES=(".join(',',@GENERATION_CONDITION).");\n" if(@GENERATION_CONDITION);
     print EN "1;\n";
    close( EN );
}

exit (Source($out_file));

sub getdir
{
my ($dir, $name, $ext) = SplitFileName( shift );
$dir=~s|[\\\/]$||;
return $dir if($dir ne '');
return ".";
}
1;
