##!perl -w
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2005-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################
#TestRTctld.exe perl launcher is located in bin and execute this perl sript which is located in the lib/scripts
#TestRTctld.pl open the envNode perl file given as the second parameter
################################################################################
#$Id: trtld.pl,v 1.1.2.7 2011/04/01 21:06:01 rfrance Exp $
################################################################################

# useful for stdout/stderr direct viewing inside 'console' of studio window
# (better: we have stdout/stderr lines in right order and not stderr before stdout
use FileHandle ;
STDOUT->autoflush(1);
STDERR->autoflush(1);

## globals ############
$main::TestRTCC=1;
#######################
$main::SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
my $nodeSettings='envNode.pl';
$OUTDIR='.';
$INIFILE='tp.ini';
$STAGE ='l';
$LOGFILENAME='trtld.log';
require $SCRIPTDIR ."BatchCCDefaults.pl";
$USE_CFLAGS_TP=1;
$TARGETDIR=$ENV{ATLTGT};
my @locLibs;
#
# trtld -config <envNnode.pl> <objects> -rtrt_output <INTDIR>/<TESTPROGRAM> -- <LDFLAGS> 
#
#  INTDIR is set from -o option if not yet specified in the envNode.pl
my $onCompilerOptions=0;
while(@ARGV) {
    $_=shift(@ARGV);
    unless($onCompilerOptions){
	if(/^-/){
	    if(/^-(o|rtrt_output)(.*)$/){
	        my $outType=$2;
	        $GENERATION_FORMAT="EXE";
	        if($outType=~m/:shared/){
	            $GENERATION_FORMAT="DLL";
	        }elsif($outType=~m/:static/){
	            $GENERATION_FORMAT="LIB";
	        }
			$TESTPROGRAM=shift(@ARGV);
			$TESTPROGRAM=~s/\"//g;
	    } elsif($_ eq "--"){#separator cmd
			$onCompilerOptions=1;
	    } elsif(/^-config/){
			$nodeSettings=shift(@ARGV);
			$nodeSettings=~s/\"//g;
			die "$nodeSettings not found. Unable to Launch command.\n" unless (-f $nodeSettings);
			require $nodeSettings;
			
	    } elsif(/^-L/){
			my $libPath = $_;
			$libPath =~s/^-L//;
			push( @LIBRARY_DIR_LIST, $libPath );
		} elsif(/^-l/){
			my $lib = $_;
			$lib =~s/^-l//;
			push(@locLibs,$lib);			
		} else {
			$LDFLAGS.=' '.$_;	    	
	    }
	} else {
	        s/\"//g;
	    	push(@OBJECTS,$_);
	}
    } else {
    	$LDFLAGS.=' '.$_;
    }
}

require $main::SCRIPTDIR."Application.pl";
require $main::SCRIPTDIR."Library.pl";

my ($dir, $name, $ext) = SplitFileName( $TESTPROGRAM );
$ATL_OUT_FILE =$name.'.spt';
$dir=~s|[\\\/]$||;
$INTDIR=$dir if($INTDIR eq '');
$INTDIR='.' if($INTDIR eq '');
@INCLUDE_DIR_LIST=@COMPIL_INCLUDE_DIR;
@GENERATION_CONDITION=@COMPIL_DEFINES;

CheckIntDir();
CheckOutDir();
EnterInScript();
foreach(@locLibs){
	$LIBRARIES.=' '.$Ini{LIBPREFIX}.$_;
}
exit (Application()) if($GENERATION_FORMAT eq "EXE");
exit (Library());

1;
