

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* $Id: atv.c,v 1.28.2.26 2011/06/28 10:00:51 rfrance Exp $
* $Descr: Unit Testing Library Source (included by TP.c[pp]) $
*******************************************************************************/
#define ATV_WORD_PREFIX ',' /* postpro does not interpret the following word */
#ifndef ATL_PTU_NIL
/* allow to optimize code for tiny target via TDP */
#define ATL_PTU_NIL() ATL_LINE_ADD_OPCODE(",NIL")
#endif
#define ATU_ABS(x) ((x) < 0 ? -(x) : (x))

#ifdef _ATL_EXIT_PENDING
RTRT_STATICFCT void atv_exit_pending (
#if !RTRT_KR
void
#endif
)
{
#ifdef ATV_EXIT_PENDING
   ATV_EXIT_PENDING
#endif
}
#else /* _ATL_EXIT_PENDING */
RTRT_STATICFCT void atv_late_exit (
#if !RTRT_KR
void
#endif
)
{
#ifdef ATV_LATE_EXIT
   ATV_LATE_EXIT
#endif
}
#endif /* _ATL_EXIT_PENDING */

RTRT_STATICFCT void atv_early_init (
#if !RTRT_KR
void
#endif
)
{
#ifdef ATV_EARLY_INIT
   ATV_EARLY_INIT
#endif
}


#ifndef ATV_ARRAY_MAX_DIM
#define ATV_ARRAY_MAX_DIM 7
#endif
#if ATV_ARRAY_MAX_DIM
/* runtime var for ARRAY */
unsigned int _atv_current_idx;
RTRT_STATICVAR unsigned int _atv_array_mode; /* =current level */
RTRT_STATICVAR unsigned int _atv_global_result;
RTRT_STATICVAR RTRT_U_INT32 _atv_block_idx[ATV_ARRAY_MAX_DIM];
RTRT_STATICVAR RTRT_U_INT32 _atv_global_idx;
#endif /* ATV_ARRAY_MAX_DIM */

#if ATVUSE_STUBS
RTRT_STATICVAR int _atv_stub_num;
RTRT_STATICVAR int _atv_stub_result;
RTRT_STATICVAR int _atv_stub_min;
RTRT_STATICVAR int _atv_stub_max;
#endif
#if RTRT_CLOCK != RTRT_NONE
RTRT_STATICVAR _ATV_LARGEST_INT _atv_start_time;
#endif /* RTRT_CLOCK != RTRT_NONE */

/* coverage data report _atu_num_current_op and _atu_num_current_test */
#define _atu_num_current_op _atv_num_current_op
#define _atu_num_current_test _atv_num_current_tcid
RTRT_STATICVAR atv_id_type _atv_num_current_op; /* 0=init, 1=tc, 2=fin */
RTRT_STATICVAR atv_id_type _atv_num_current_tcid;
RTRT_STATICVAR atv_id_type _atv_num_current_loop;

#if USE_ATC || USE_ATP || USE_ATQ || USE_ATT
#if RTRT_TINY_TARGET
#define ATU_SET_SERV_NAME(s)
#define ATU_SET_TEST_NAME(s)
#else
RTRT_STATICVAR char *_atu_name_current_op;
RTRT_STATICVAR char *_atu_name_current_test;
#define ATU_SET_SERV_NAME(s) _atu_name_current_op=s;
#define ATU_SET_TEST_NAME(s) _atu_name_current_test=s;
#endif
/* RTRT_STATICVAR int _atv_obs_tool_flag; */
#endif

RTRT_STATICVAR char _atv_testError;
#if USE_ATT
/*RTRT_STATICVAR char _atv_stubExec; */
RTRT_STATICVAR char _atv_loopError;
RTRT_STATICVAR unsigned int _atv_current_source;
RTRT_STATICVAR char _atv_stubCalled;
/* dynamic ATT id */
#define ATV_TEST_INSTANCE 1
#define ATV_LOOP_INSTANCE 2
#define ATV_STUB_INSTANCE 3
#define ATV_SOURCE_SUITE 1
/* stub name id */
/* the first label in the tsf file is for "STUBS" */
#define ATV_ATT_STUB_NAME(x) x+10
/* static ATT id */
#define ATV_TEST_LINE 1
#define ATV_TEST_MSG 2
#define ATV_LOOP_LINE 3
#define ATV_LOOP_MSG 4
/*
#define ATV_TEST_OK 7
#define ATV_TEST_KO 5
#define ATV_UNEXPECTED_CALL ??
#define ATV_GLYPH_TXT 8
#define ATV_TX_ERROR 6
*/
#define ATV_TEST_OK 5
#define ATV_TEST_KO (ATV_TEST_OK+1)
#define ATV_UNEXPECTED_CALL (ATV_TEST_OK+2)
#define ATV_GLYPH_TXT 8
#define ATV_TX_ERROR 9

#define _ATV_SETERROR _atv_loopError |=1;
#else
#define _ATV_SETERROR _atv_testError |=1;
#endif

#if USE_ATT
#if RTRT_CPLUSPLUS_LANGUAGE
extern "C" {
#endif
#if !RTRT_KR
RTRT_GLOBALFCT void _att_print_change_instance ( RTRT_U_INT32 instance_id );
#else
RTRT_GLOBALFCT void _att_print_change_instance ( );
#endif
#if RTRT_CPLUSPLUS_LANGUAGE
} // end of extern "C"
#endif
#endif /* USE_ATT */


#define LINETYPEINI 2
#define LINETYPEARRAY 3
#define LINETYPELOOP 4
#define LINETSID 5
#define LINETYPENEWTEST 6
#define LINETCID 7
#define LINETYPEBREDCRUMB 8
#define LINETYPESTUBERROR 9
/* id: editor ID, lineType: LINETYPEINI for init, 0 for ev false, 1 for ev true
*/
RTRT_STATICFCT void atv_var_num
#if !RTRT_KR
  (atv_id_type id, char lineType)
#else
  (id, lineType)
  atv_id_type id;
  char lineType;
#endif
{
  atl_line_add_char('I');
  atl_line_add_char(('0'+lineType));
  atl_line_add_char(' ');
  atl_line_inc(unsigned_reverse_large_image_16(id, atl_line_cur));
  atl_line_add_char(' ');
  if(lineType==0)
  {
	  _ATV_SETERROR
#if ATU_BREAK_ON_TEST_FAILED
	  priv_check_failed ();
#endif
  }
}

#if ATV_ARRAY_MAX_DIM
void set_mode_tab
#if !RTRT_KR
(int numDim,int DimSize)
#else
(numDim,DimSize)
int numDim;
int DimSize;
#endif
{
 if(numDim)
 {
	 _atv_block_idx[numDim]=(_atv_block_idx[numDim-1]+_atv_current_idx)*DimSize;
#define  set_atv_global_idx (_atv_block_idx[_atv_array_mode-1]+_atv_current_idx)
 }
 else
 {
  _atv_global_result = 1;
  _atv_block_idx[0] = 0;
  _atv_global_idx = 0;
  atv_var_num(_atv_global_idx,LINETYPEARRAY);
  atl_line_dump();
 }
  _atv_array_mode = numDim+1;

}

void atv_array_idx ()
{
	if(_atv_global_idx != set_atv_global_idx)
    {
		_atv_global_idx = set_atv_global_idx;
		atv_var_num(_atv_global_idx,LINETYPEARRAY);
        atl_line_dump();
	}
	_atv_global_idx++;
}

void unset_mode_tab
#if !RTRT_KR
(int numDim)
#else
(numDim)
int numDim;
#endif
{
 if(numDim)
 {
 }
 else
 {
  _atv_array_mode = 0;
  atv_var_num(_atv_global_idx,LINETYPEARRAY);
  atl_line_add_char((_atv_global_result?'T':'F'));
  atl_line_dump();
  /* for memory overwrite check */
  _atv_global_result=1;
  _atv_global_idx=0;
 }
}

void _atv_cpy
#if !RTRT_KR
	(unsigned int typesize,	unsigned int arraysize,	char* var,	char* value,  atv_isLit_type isLiteral)
#else
	(typesize,arraysize,var,value,isLiteral)
	unsigned int typesize;
	unsigned int arraysize;
	char* var;
	char* value;
  atv_isLit_type isLiteral;
#endif
{
	unsigned int i=arraysize*typesize;
	atv_flag_type f=(isLiteral==4 && (typesize==1));
	while(i--)
	{
		*var++=*value;
		if((*value++ ==0) && f) return;
	}
}
#endif /*ATV_ARRAY_MAX_DIM*/


#if RTRT_STRING && ATVUSE_STRING

#if !RTRT_KR
RTRT_STATICFCT atv_flag_type atv_comp_3_str(unsigned char checkType, unsigned int arraysizeMax, atv_string value_min, atv_string value, atv_string value_max)
#else
RTRT_STATICFCT atv_flag_type atv_comp_3_str(checkType, arraysizeMax, value_min, value, value_max)
atv_ckt_type checkType;
unsigned int arraysizeMax;
atv_string value_min;
atv_string value;
atv_string value_max;
#endif
{
  char mynil='\0';
  int i, j;
  unsigned int k;
  if (value == NIL)
    {
	  if(    ((checkType & 1) && (value_min == NIL)) ||
	     (   ((checkType & 4) || (value_max == NIL))
	       &&((checkType & 8) || (value_max != NIL)) )
	  ) return 1;
	  return 0;
    }
  if(value_min == NIL) value_min=&mynil;
  if(value_max == NIL) value_max=&mynil;
  i = 0;
  j = 0;
  if(arraysizeMax==0) arraysizeMax=RTRT_LARGEST_STRING;
  k = arraysizeMax-1;
  while ((k) && ((value_min[i]) == (value[i])) && ((value[i]) == (value_max[i])) && ((value_min[i]) != '\0'))
	{
	  i++;
	  k--;
	}
  j = i;
  while ((k) && (value_min[i]) == (value[i]) && ((value_min[i]) != '\0') )
	{
	  i++;
	  k--;
	}
  k = arraysizeMax-j-1;
  while ((k) && (value_max[j]) == (value[j]) && ((value_max[j]) != '\0'))
	{
	  j++;
	  k--;
	}
  if(    ((checkType & 1) && (value[i] == value_min[i])) ||
     (   ((checkType & 2) || (value[i] >  value_min[i]))
       &&((checkType & 4) || (value[j] <= value_max[j]))
       &&((checkType & 8) || (value[j] != value_max[j])) )
    ) return 1;
  return(0);
}

#undef RTRT_STR_CONCAT_SUPPORTED /* on vera plus tard */
#define RTRT_STR_CONCAT_SUPPORTED 0
#if RTRT_STR_CONCAT_SUPPORTED

RTRT_STATICVAR char _atv_string_pool[3][ATU_STRING_SIZE+1];
RTRT_STATICVAR int  _atv_string_num;

#if !RTRT_KR
char * CONCAT_STR_C(atv_string str, ...)
#else
char * CONCAT_STR_C(va_alist)
va_dcl
#endif
{
  va_list t;
  int len;

#if !RTRT_KR
  const char * ptr;
  va_start(t, str);
  ptr = str;
#else
  char * ptr;
  va_start(t);
  ptr = va_arg(t, char *);
#endif

  len = 0;
  while (ptr)
    {
      while((*ptr) && (len < ATU_STRING_SIZE))
        {
          _atv_string_pool[_atv_string_num][len] = *ptr;
          ptr++;
          len++;
        }
      ptr = va_arg(t, char *);
    }
  _atv_string_pool[_atv_string_num][len] = 0;
  va_end(t);
  return(_atv_string_pool[_atv_string_num++]);
}

#endif /* RTRT_STR_CONCAT_SUPPORTED */


RTRT_STATICFCT void atl_buffer_quoted_string_image (const char *s,unsigned int l)
{
  if(s)
  {
	*atl_buffer_next++ =RTRT_QUOT;
	atl_buffer_stringl_image(s,l);
	*atl_buffer_next++ =RTRT_QUOT;
  }
  else
  {
	  ATL_PTU_NIL();
  }
}


#ifndef INCORRECT_STR_INIT
#define INCORRECT_STR_INIT() ATL_LINE_ADD_OPCODE(" !! ? !!")
#endif

#if 0 /* ATVUSE_INI_STR_C */
#if !RTRT_KR
void atv_ini_str(char * s, int aff_val, long num, atv_string val)
#else
void atv_ini_str(s, aff_val, num, val)
char * s;
int  aff_val;
long num;
atv_string val;
#endif
{
  int i;

  if (s)
    {
      if (!val) val = RTRT_CONST_STRING( "?" );
      for (i=0; val[i]; i++) s[i] = val[i];
      s[i] = '\0';
#if RTRT_STR_CONCAT_SUPPORTED
      _atv_string_num = 0;
#endif
      if (aff_val)
        {
		  atv_var_num(num, LINETYPEINI);
          atl_buffer_quoted_string_image (s,i);
          atl_line_dump();
        }
      else
        {
        }
    }
  else
    {
      atv_var_num(num, LINETYPEINI);
      INCORRECT_STR_INIT();
      atl_line_dump();
    }
}
#endif /*ATVUSE_INI_STR_C*/

#if !RTRT_KR
void _atv_i_string(atv_string value, atv_id_type id)
#else
void _atv_i_string(value, id)
atv_string value;
atv_id_type id;
#endif
{
#if ATV_REPORT_OUTLAY
#if ATV_ARRAY_MAX_DIM
  if (!_atv_array_mode)
#endif /* ATV_ARRAY_MAX_DIM */
#endif /* do not print init value for array mode when outlay !=0 */
    {
		atv_var_num(id, LINETYPEINI);
		atl_buffer_quoted_string_image (value,0);
		atl_line_dump();
    }
}

#if !RTRT_KR
atv_flag_type _atv_e_stringl(atv_ckt_type checkType, unsigned int arraysizeMax, atv_string value, atv_id_type id, atv_string value_min, atv_string value_max, atv_isLit_type isLiteral)
#else
atv_flag_type _atv_e_stringl(checkType, arraysizeMax, value, id, value_min, value_max, isLiteral)
atv_ckt_type checkType;
atv_isLit_type isLiteral;
unsigned int arraysizeMax,
atv_string value;
atv_id_type id;
atv_string value_min;
atv_string value_max;
#endif
{
	atv_flag_type ok=atv_comp_3_str(checkType, arraysizeMax, value_min, value, value_max);

#if ATV_ARRAY_MAX_DIM
  if (_atv_array_mode)
    {
#if ATV_REPORT_OUTLAY
      if (ok)
        {
			return ok;
        }
      else
#endif
        {
          _atv_global_result = 0;
          atv_array_idx();
        }
    }
#endif /* ATV_ARRAY_MAX_DIM */
   if(id)
	  {
		atv_var_num(id, ok);
	    atl_buffer_quoted_string_image (value,arraysizeMax);
		if(!isLiteral && (checkType!= (atv_ckt_type)RTRT_EVUNCHK) && (value))
		{
			atl_line_add_char(' ');
			if (value_min!=value_max)
			  {
				atl_buffer_quoted_string_image (value_min,arraysizeMax);
				atl_line_add_char(' ');
			  }
			atl_buffer_quoted_string_image (value_max,arraysizeMax);
		}
		atl_line_dump();
	  }

#if RTRT_STR_CONCAT_SUPPORTED
  _atv_string_num = 0;
#endif
  return ok;
}

#endif /* RTRT_STRING && ATVUSE_STRING */

#if ATVUSE_CHAR
#if !RTRT_KR
void _atv_i_char(char value, atv_id_type id)
#else
void _atv_i_char(value, id)
char value;
atv_id_type id;
#endif
{
#if ATV_REPORT_OUTLAY
#if ATV_ARRAY_MAX_DIM
  if (!_atv_array_mode)
#endif /* ATV_ARRAY_MAX_DIM */
#endif /* do not print init value for array mode when outlay !=0 */
    {
		atv_var_num(id, LINETYPEINI);
		atl_line_inc(char_image(value, atl_line_cur));
		atl_line_dump();
    }
}


#if !RTRT_KR
atv_flag_type _atv_e_char(atv_ckt_type checkType, char value, atv_id_type id, char value_min, char value_max, atv_isLit_type isLiteral)
#else
atv_flag_type _atv_e_char(checkType, value, id, value_min, value_max, isLiteral)
atv_id_type id;
atv_ckt_type checkType;
atv_isLit_type isLiteral;
char value, value_min, value_max;
#endif
{
atv_flag_type ok=0;
  if(    ((checkType & 1) && (value == value_min)) ||
     (   ((checkType & 2) || (value >  value_min))
       &&((checkType & 4) || (value <= value_max))
       &&((checkType & 8) || (value != value_max)) )
    ) ok=1;

#if ATV_ARRAY_MAX_DIM
  if (_atv_array_mode)
    {
#if ATV_REPORT_OUTLAY
      if (ok)
        {
			return ok;
        }
      else
#endif
        {
          _atv_global_result = 0;
          atv_array_idx();
        }
    }
#endif /*ATV_ARRAY_MAX_DIM*/
   if(id)
    {
      atv_var_num(id, ok);
      atl_line_inc(char_image(value, atl_line_cur));
      if (!isLiteral)
        {
		  atl_line_add_char(' ');
		  if(value_min != value_max)
		  {
			  atl_line_inc(char_image(value_min, atl_line_cur));
			  atl_line_add_char(' ');
		  }
		  atl_line_inc(char_image(value_max, atl_line_cur));
        }
      atl_line_dump();
    }
    return ok;
}
#endif /* ATVUSE_CHAR */

#if ATVUSE_INTEGER
#if !RTRT_KR
void _atv_i_integer(atv_integer value, atv_id_type id)
#else
void _atv_i_integer(value, id)
atv_integer value;
atv_id_type id;
#endif
{
#if ATV_REPORT_OUTLAY
#if ATV_ARRAY_MAX_DIM
  if (!_atv_array_mode)
#endif /* ATV_ARRAY_MAX_DIM */
#endif /* do not print init value for array mode when outlay !=0 */
    {
		atv_var_num(id, LINETYPEINI);
		atl_line_inc(integer_reverse_large_image_16(value, atl_line_cur));
		atl_line_dump();
    }
}

#if !RTRT_KR
atv_flag_type _atv_e_integer(atv_ckt_type checkType, atv_integer value, atv_id_type id, atv_integer value_min, atv_integer value_max, atv_isLit_type isLiteral)
#else
atv_flag_type _atv_e_integer(checkType, value, id, value_min, value_max, isLiteral)
atv_id_type id;
atv_ckt_type checkType;
atv_isLit_type isLiteral;
atv_integer value, value_min, value_max;
#endif
{
atv_flag_type ok=0;
  if(    ((checkType & 1) && (value == value_min)) ||
     (   ((checkType & 2) || (value >  value_min))
       &&((checkType & 4) || (value <= value_max))
       &&((checkType & 8) || (value != value_max)) )
    ) ok=1;

#if ATV_ARRAY_MAX_DIM
  if (_atv_array_mode)
    {
#if ATV_REPORT_OUTLAY
      if (ok)
        {
			return ok;
        }
      else
#endif
        {
          _atv_global_result = 0;
          atv_array_idx();
        }
    }
#endif /* ATV_ARRAY_MAX_DIM */
  if(id)
    {
      atv_var_num(id, ok);
      atl_line_inc(integer_reverse_large_image_16(value, atl_line_cur));
      if (!isLiteral)
        {
		  atl_line_add_char(' ');
          atl_line_inc(integer_reverse_large_image_16(value_min, atl_line_cur));
		  if(value_min != value_max)
		  {
              atl_line_add_char(' ');
              atl_line_inc(integer_reverse_large_image_16(value_max, atl_line_cur));
		  }
        }
      atl_line_dump();
    }
  return ok;
}
#endif /* ATVUSE_INTEGER */

#if ATVUSE_UNSIGNED
#if !RTRT_KR
void _atv_i_unsigned(atv_unsigned value, atv_id_type id)
#else
void _atv_i_unsigned(value, id)
atv_unsigned value;
atv_id_type id;
#endif
{
#if ATV_REPORT_OUTLAY
#if ATV_ARRAY_MAX_DIM
  if (!_atv_array_mode)
#endif /* ATV_ARRAY_MAX_DIM */
#endif /* do not print init value for array mode when outlay !=0 */
    {
		atv_var_num(id, LINETYPEINI);
		atl_line_inc(unsigned_reverse_large_image_16(value, atl_line_cur));
		atl_line_dump();
    }
}

#if !RTRT_KR
atv_flag_type _atv_e_unsigned(atv_ckt_type checkType, atv_unsigned value, atv_id_type id, atv_unsigned value_min, atv_unsigned value_max, atv_isLit_type isLiteral)
#else
atv_flag_type _atv_e_unsigned(checkType, value, id, value_min, value_max, isLiteral)
atv_id_type id;
atv_ckt_type checkType;
atv_isLit_type isLiteral;
atu_unsigned value, value_min, value_max;
#endif
{
atv_flag_type ok=0;
  if(    ((checkType & 1) && (value == value_min)) ||
     (   ((checkType & 2) || (value >  value_min))
       &&((checkType & 4) || (value <= value_max))
       &&((checkType & 8) || (value != value_max)) )
    ) ok=1;

#if ATV_ARRAY_MAX_DIM
  if (_atv_array_mode)
    {
#if ATV_REPORT_OUTLAY
      if (ok)
        {
			return ok;
        }
      else
#endif
        {
          _atv_global_result = 0;
          atv_array_idx();
        }
    }
#endif /* ATV_ARRAY_MAX_DIM */
   if(id)
    {
      atv_var_num(id, ok);
      atl_line_inc(unsigned_reverse_large_image_16(value, atl_line_cur));
      if (!isLiteral)
        {
		  atl_line_add_char(' ');
          atl_line_inc(unsigned_reverse_large_image_16((_ATV_LARGEST_INT)value_min, atl_line_cur));
		  if(value_min != value_max)
		  {
              atl_line_add_char(' ');
			  atl_line_inc(unsigned_reverse_large_image_16((_ATV_LARGEST_INT)value_max, atl_line_cur));
		  }
        }
      atl_line_dump();
    }
   return ok;
}
#endif /*ATVUSE_UNSIGNED*/

#if ATVUSE_BOOLEAN
#if !RTRT_KR
void _atv_i_boolean(int value, atv_id_type id)
#else
void _atv_i_boolean(value, id)
int value;
atv_id_type id;
#endif
{
#if ATV_REPORT_OUTLAY
#if ATV_ARRAY_MAX_DIM
  if (!_atv_array_mode)
#endif /* ATV_ARRAY_MAX_DIM */
#endif /* do not print init value for array mode when outlay !=0 */
    {
		atv_var_num(id, LINETYPEINI);
		atl_line_add_char((value?'T':'F'));
		atl_line_dump();
    }
}

#if !RTRT_KR
atv_flag_type _atv_e_boolean(atv_ckt_type checkType, int value, atv_id_type id, int value_min, int value_max, atv_isLit_type isLiteral)
#else
atv_flag_type _atv_e_boolean(checkType, value, id, value_min, value_max,isLiteral)
atv_id_type id;
atv_ckt_type checkType;
atv_isLit_type isLiteral;
int value, value_min, value_max;
#endif
{
atv_flag_type ok=0;
  if(    ((checkType & 1) && (value == value_min)) ||
     (   ((checkType & 2) || (value >  value_min))
       &&((checkType & 4) || (value <= value_max))
       &&((checkType & 8) || (value != value_max)) )
    ) ok=1;

#if ATV_ARRAY_MAX_DIM
  if (_atv_array_mode)
    {
#if ATV_REPORT_OUTLAY
      if (ok)
        {
			return ok;
        }
      else
#endif
        {
          _atv_global_result = 0;
          atv_array_idx();
        }
    }
#endif /*ATV_ARRAY_MAX_DIM*/
  if(id)
    {
      atv_var_num(id, ok);
      atl_line_add_char((value?'T':'F'));
      if (!isLiteral)
      {
		  atl_line_add_char(' ');
          atl_line_add_char((value_min?'T':'F'));
	  }
      atl_line_dump();
    }
  return ok;
}
#endif /*ATVUSE_BOOLEAN*/

#if ATVUSE_POINTER
#if !RTRT_KR
atv_flag_type _atv_e_pointer(atv_ckt_type checkType, atv_pointer value, atv_id_type id, atv_pointer value_min, atv_pointer value_max, atv_isLit_type isLiteral)
#else
atv_flag_type _atv_e_pointer(checkType, value, id, value_min, value_max, isLiteral)
atv_id_type id;
atv_ckt_type checkType;
atv_isLit_type isLiteral;
atv_pointer value,value_min,value_max;
#endif
{

#ifdef RTRT_NO_DOUBLE_CONVERSION
  _ATU_POINTER_CONVERSION convert_value = (_ATU_POINTER_CONVERSION) value;
  _ATU_POINTER_CONVERSION convert_value_min = (_ATU_POINTER_CONVERSION) value_min;
  _ATU_POINTER_CONVERSION convert_value_max = (_ATU_POINTER_CONVERSION) value_max;
#else
#define convert_value (_ATU_POINTER_CONVERSION) value
#define convert_value_min (_ATU_POINTER_CONVERSION) value_min
#define convert_value_max (_ATU_POINTER_CONVERSION) value_max
#endif

 atv_flag_type ok=0;
  if(     (checkType==(atv_ckt_type)RTRT_EVUNCHK) ||
	 (    (checkType & 1) && ((value == value_min)) ) ||
     (   ((checkType & 2) || (value >  value_min))
       &&((checkType & 4) || (value <= value_max))
       &&((checkType & 8) || (value != value_max))  )
    ) ok=1;

#if ATV_ARRAY_MAX_DIM
  if (_atv_array_mode)
    {
#if ATV_REPORT_OUTLAY
      if (ok)
        {
			return ok;
        }
      else
#endif
        {
          _atv_global_result = 0;
          atv_array_idx();
        }
    }
#endif /*ATV_ARRAY_MAX_DIM*/
  if(id)
    {
      atv_var_num(id, ok);
      atl_line_inc(unsigned_reverse_large_image_16((atv_unsigned) convert_value, atl_line_cur));
      if (!isLiteral)
        {
		  atl_line_add_char(' ');
          atl_line_inc(unsigned_reverse_large_image_16((atv_unsigned) convert_value_min, atl_line_cur));
		  if(value_min != value_max)
		  {
              atl_line_add_char(' ');
			  atl_line_inc(unsigned_reverse_large_image_16((atv_unsigned) convert_value_max, atl_line_cur));
	      }
        }
      atl_line_dump();
    }
   return ok;
}

#if !RTRT_KR
void _atv_i_pointer(atv_pointer value, atv_id_type id)
#else
void _atv_i_pointer(value, id)
atv_pointer value;
atv_id_type id;
#endif
{
#if ATV_REPORT_OUTLAY
#if ATV_ARRAY_MAX_DIM
  if (!_atv_array_mode)
#endif /* ATV_ARRAY_MAX_DIM */
#endif /* do not print init value for array mode when outlay !=0 */
    {
		atv_var_num(id, LINETYPEINI);
		atl_line_inc(unsigned_reverse_large_image_16((atv_unsigned)value, atl_line_cur));
		atl_line_dump();
    }
}
#endif /*ATVUSE_POINTER*/

#if RTRT_FLOAT
#if ATVUSE_FLOAT+ATVUSE_DOUBLE

#if RTRT_FLOAT_NAN

#ifndef ATU_FLOAT_CHECK_TABLE
#define ATU_FLOAT_CHECK_TABLE(miType,maType,vType) atv_float_check_table[(miType<<4)+(maType<<2)+vType]
unsigned char atv_float_check_table[]={
		/* Min       Max       0=NaN    1=-inf	 2=val     3=+inf */
		/*	0,        0, */     0x05,    0x00,    0x00,     0x00,
		/*	0,        1, */     0x41,    0x44,    0x40,     0x40,
		/*	0,        2, */     0x41,    0x4C,    0x60,     0x40,
		/*	0,        3, */     0x41,    0x4C,    0x4C,     0x44,
		/*	1,        0, */     0x44,    0x41,    0x43,     0x43,
		/*	1,        1, */     0x00,    0x05,    0x03,     0x03,
		/*	1,        2, */     0x40,    0x4D,    0x63,     0x43,
		/*	1,        3, */     0x40,    0x4D,    0x4F,     0x47,
		/*	2,        0, */     0x44,    0x40,    0x50,     0x43,
		/*	2,        1, */     0x40,    0x44,    0x40,     0x43,
		/*	2,        2, */     0x00,    0x0C,    0x30,     0x03,
		/*	2,        3, */     0x40,    0x4C,    0x5C,     0x47,
		/*	3,        0, */     0x44,    0x40,    0x40,     0x41,
		/*	3,        1, */     0x40,    0x44,    0x40,     0x41,
		/*	3,        2, */     0x40,    0x4C,    0x40,     0x41,
		/*	3,        3, */     0x00,    0x0C,    0x0C,     0x05
};
#endif /* ATU_FLOAT_CHECK_TABLE */

RTRT_STATICFCT void outbound_float_image
#if !RTRT_KR
  (unsigned char fcode)
#else
  (fcode)
  unsigned char fcode;
#endif
{
	if(fcode==3)   ATL_LINE_ADD_OPCODE("+Inf");
	else if(fcode) ATL_LINE_ADD_OPCODE("-Inf");
	else           ATL_LINE_ADD_OPCODE("NaN");
}

#if ATVUSE_FLOAT
#ifdef RTRT_FLOAT_TYPE
#define ATU_FLOAT_TYPE(f) RTRT_FLOAT_TYPE(f)
#endif
#ifndef ATU_FLOAT_TYPE
#define ATU_FLOAT_TYPE(f) atv_float_type(f)
unsigned char atv_float_type(float x) /* return 0=NaN 1=-inf 2=val 3=+inf */
{
  int res;
  res=2;
  if ((x * (float)0.5)==x)
    {
      if (x==(float)0.0)
        {
			if(x==x+(float)1.0) res=0;/* windows bug NaN==0.0 return always true */
			else res=2;
		}
      else
        {
		  if (x>(float)0.0)
			{
			  if (x<(float)0.0) res=0;
			  else res=3;
			}
		  else
			{
			  if (x<(float)0.0) res=1;
			  else res=0;
			}
		}
    }
  else
    {
      if ( x == x) res=2;
      else res=0;
    }
  return(res);
}
#endif /* ATU_FLOAT_TYPE */
#endif /* ATVUSE_FLOAT */

#if ATVUSE_DOUBLE
#ifdef RTRT_DOUBLE_TYPE
#define ATU_DOUBLE_TYPE(f) RTRT_DOUBLE_TYPE(f)
#endif
#ifndef ATU_DOUBLE_TYPE
#define ATU_DOUBLE_TYPE(f) atv_double_type(f)
unsigned char atv_double_type(double x) /* return 0=NaN 1=-inf 2=val 3=+inf */
{
  int res;
  res=2;
  if ((x * (double)0.5)==x)
    {
      if (x==(double)0.0)
        {
			if(x==x+(double)1.0) res=0;/* windows bug NaN==0.0 return always true */
			else res=2;
		}
      else
        {
		  if (x>(double)0.0)
			{
			  if (x<(double)0.0) res=0;
			  else res=3;
			}
		  else
			{
			  if (x<(double)0.0) res=1;
			  else res=0;
			}
		}
    }
  else
    {
      if ( x == x) res=2;
      else res=0;
    }
  return(res);
}
#endif /* ATU_DOUBLE_TYPE */
#endif /*ATVUSE_DOUBLE*/


#if ATVUSE_FLOAT
#define ATU_FLOAT_IMAGE(c,f) float_image2(c,f)
RTRT_STATICFCT void float_image2
#if !RTRT_KR
  (unsigned char fcode, float f)
#else
  (fcode,f)
  unsigned char fcode;
  float f;
#endif
{
	if(fcode==2)
		atl_line_inc(float_image(f, atl_line_cur));
	else
		outbound_float_image(fcode);
}
#endif /*ATVUSE_FLOAT*/

#if ATVUSE_DOUBLE
#define ATU_DOUBLE_IMAGE(c,f) double_image2(c,f)
RTRT_STATICFCT void double_image2
#if !RTRT_KR
  (unsigned char fcode, double f)
#else
  (fcode,f)
  unsigned char fcode;
  double f;
#endif
{
	if(fcode==2)
		atl_line_inc(double_image(f, atl_line_cur));
	else
		outbound_float_image(fcode);
}
#endif /*ATVUSE_DOUBLE*/
#else /* RTRT_FLOAT_NAN */

#ifndef ATU_FLOAT_TYPE
#define ATU_FLOAT_TYPE(f) 2
#endif

#ifndef ATU_DOUBLE_TYPE
#define ATU_DOUBLE_TYPE(f) 2
#endif

#define ATU_FLOAT_IMAGE(c,f) atl_line_inc(float_image(f, atl_line_cur))
#define ATU_DOUBLE_IMAGE(c,f) atl_line_inc(double_image(f, atl_line_cur))

#endif /* RTRT_FLOAT_NAN */

#if ATVUSE_FLOAT
#if !RTRT_KR
atv_flag_type _atv_e_float(atv_ckt_type checkType, float value, atv_id_type id, float value_min, float value_max, atv_isLit_type isLiteral)
#else
atv_flag_type _atv_e_float(checkType, value, id, value_min, value_max, isLiteral)
atv_ckt_type checkType;
atv_isLit_type isLiteral;
atv_id_type id;
float value, value_min, value_max;
#endif
{
  atv_flag_type ok=0;
#if RTRT_FLOAT_NAN
#define FLOAT_FORCE_MAX_DISP (Comp & 0x40) ||
  atv_ckt_type Comp;
	  double miDelta,maDelta;
	  unsigned char miType=0;
	  unsigned char maType=0;
	  unsigned char vType = ATU_DOUBLE_TYPE(value);/* return 0=NaN 1=-inf 2=val 3=+inf */
	  if (checkType==(atv_ckt_type)RTRT_EVUNCHK)
	  {
		ok=1;
		isLiteral=1;
	  }
	  else
	  {
	   	miType = ATU_FLOAT_TYPE(value_min);
	   	if(miType==2)
			miDelta=ATU_ABS(value_min) * ATL_EPSILON_FLT;

		maType = ATU_FLOAT_TYPE(value_max);
		if(maType==2)
			maDelta=ATU_ABS(value_max) * ATL_EPSILON_FLT;

	    Comp  = (checkType >>4) | ATU_FLOAT_CHECK_TABLE(miType,maType,vType);

		  if(  ((Comp & 0x1) || ((Comp & 0x10) && (value >= (value_min - miDelta))))
	         &&((Comp & 0x2) || ((Comp & 0x10) && (value >  (value_min + miDelta))))
			 &&((Comp & 0x4) || ((Comp & 0x20) && (value <= (value_max + maDelta))))
			 &&((Comp & 0x8) || ((Comp & 0x20) && (value <  (value_max - maDelta))))
		    ) ok=1;
		if(checkType == (atv_ckt_type)RTRT_EVCHK2) {ok^=1;}
	  }
#else /*RTRT_FLOAT_NAN*/
#define FLOAT_FORCE_MAX_DISP
 if(    ((checkType & 0x10) || (value >= (value_min - ATU_ABS(value_min) * ATL_EPSILON_FLT)))
      &&((checkType & 0x20) || (value >  (value_min + ATU_ABS(value_min) * ATL_EPSILON_FLT)))
      &&((checkType & 0x40) || (value <= (value_max + ATU_ABS(value_max) * ATL_EPSILON_FLT)))
      &&((checkType & 0x80) || (value <  (value_max - ATU_ABS(value_max) * ATL_EPSILON_FLT)))
   ) ok=1;
 if(checkType == (atv_ckt_type)RTRT_EVCHK2) {ok^=1;}

#endif /*RTRT_FLOAT_NAN*/

#if ATV_ARRAY_MAX_DIM
  if (_atv_array_mode)
    {
#if ATV_REPORT_OUTLAY
      if (ok)
        {
			return ok;
        }
      else
#endif
        {
          _atv_global_result = 0;
          atv_array_idx();
        }
    }
#endif /*ATV_ARRAY_MAX_DIM*/
   if(id)
    {
      atv_var_num(id, ok);
      atl_line_add_char(ATV_WORD_PREFIX);
      ATU_FLOAT_IMAGE(vType,value);
      if (!isLiteral)
        {
		  atl_line_add_char(' ');
          atl_line_add_char(ATV_WORD_PREFIX);
	      ATU_FLOAT_IMAGE(miType,value_min);
	      if(FLOAT_FORCE_MAX_DISP (value_min != value_max))
		  {
	          atl_line_add_char(' ');
              atl_line_add_char(ATV_WORD_PREFIX);
			  ATU_FLOAT_IMAGE(maType,value_max);
	      }
        }
	  atl_line_dump();
    }
  return ok;
}

#if !RTRT_KR
void _atv_i_float(float value, atv_id_type id)
#else
void _atv_i_float(value, id)
float value;
atv_id_type id;
#endif
{
#if ATV_REPORT_OUTLAY
#if ATV_ARRAY_MAX_DIM
  if (!_atv_array_mode)
#endif /* ATV_ARRAY_MAX_DIM */
#endif /* do not print init value for array mode when outlay !=0 */
    {
		atv_var_num(id, LINETYPEINI);
		atl_line_add_char(ATV_WORD_PREFIX);
		ATU_FLOAT_IMAGE(ATU_FLOAT_TYPE(value),value);
		atl_line_dump();
    }
}
#endif /*ATVUSE_FLOAT*/

#if ATVUSE_DOUBLE
#if !RTRT_KR
void _atv_i_double(double value, atv_id_type id)
#else
void _atv_i_double(value, id)
double value;
atv_id_type id;
#endif
{
#if ATV_REPORT_OUTLAY
#if ATV_ARRAY_MAX_DIM
  if (!_atv_array_mode)
#endif /* ATV_ARRAY_MAX_DIM */
#endif /* do not print init value for array mode when outlay !=0 */
    {
		atv_var_num(id, LINETYPEINI);
		atl_line_add_char(ATV_WORD_PREFIX);
		ATU_DOUBLE_IMAGE(ATU_DOUBLE_TYPE(value),value);
		atl_line_dump();
    }
}

#if !RTRT_KR
atv_flag_type _atv_e_double(atv_ckt_type checkType, double value, atv_id_type id, double value_min, double value_max, atv_isLit_type isLiteral)
#else
atv_flag_type _atv_e_double(checkType, value, id, value_min, value_max, isLiteral)
atv_ckt_type checkType;
atv_isLit_type isLiteral;
double value, value_min, value_max;
atv_id_type id;
#endif
{
  atv_flag_type ok=0;
#if RTRT_FLOAT_NAN
  atv_ckt_type Comp;
	  double miDelta,maDelta;
	  unsigned char miType=0;
	  unsigned char maType=0;
	  unsigned char vType = ATU_DOUBLE_TYPE(value);/* return 0=NaN 1=-inf 2=val 3=+inf */
  if (checkType==(atv_ckt_type)RTRT_EVUNCHK)
  {
	ok=1;
	isLiteral=1;
  }
  else
  {
   	miType = ATU_DOUBLE_TYPE(value_min);
   	if(miType==2)
		miDelta=ATU_ABS(value_min) * ATL_EPSILON_DBL;

	maType = ATU_DOUBLE_TYPE(value_max);
	if(maType==2)
		maDelta=ATU_ABS(value_max) * ATL_EPSILON_DBL;

    Comp  = (checkType >>4) | ATU_FLOAT_CHECK_TABLE(miType,maType,vType);

	  if(  ((Comp & 0x1) || ((Comp & 0x10) && (value >= (value_min - miDelta))))
         &&((Comp & 0x2) || ((Comp & 0x10) && (value >  (value_min + miDelta))))
		 &&((Comp & 0x4) || ((Comp & 0x20) && (value <= (value_max + maDelta))))
		 &&((Comp & 0x8) || ((Comp & 0x20) && (value <  (value_max - maDelta))))
	    ) ok=1;
	if(checkType == (atv_ckt_type)RTRT_EVCHK2) {ok^=1;}
  }
#else /*RTRT_FLOAT_NAN*/
  if(    ((checkType & 0x10) || (value >= (value_min - ATU_ABS(value_min) * ATL_EPSILON_DBL)))
       &&((checkType & 0x20) || (value >  (value_min + ATU_ABS(value_min) * ATL_EPSILON_DBL)))
       &&((checkType & 0x40) || (value <= (value_max + ATU_ABS(value_max) * ATL_EPSILON_DBL)))
       &&((checkType & 0x80) || (value <  (value_max - ATU_ABS(value_max) * ATL_EPSILON_DBL)))
    ) ok=1;
  if(checkType == (atv_ckt_type)RTRT_EVCHK2) {ok^=1;}
#endif /*RTRT_FLOAT_NAN*/

#if ATV_ARRAY_MAX_DIM
  if (_atv_array_mode)
    {
#if ATV_REPORT_OUTLAY
      if (ok)
        {
			return ok;
        }
      else
#endif
        {
          _atv_global_result = 0;
          atv_array_idx();
        }
    }
#endif /*ATV_ARRAY_MAX_DIM*/
  if(id)
    {
      atv_var_num(id, ok);
      atl_line_add_char(ATV_WORD_PREFIX);
      ATU_DOUBLE_IMAGE(vType,value);
      if (!isLiteral)
        {
		  atl_line_add_char(' ');
          atl_line_add_char(ATV_WORD_PREFIX);
	      ATU_DOUBLE_IMAGE(miType,value_min);
	      if(FLOAT_FORCE_MAX_DISP (value_min != value_max))
		  {
	          atl_line_add_char(' ');
              atl_line_add_char(ATV_WORD_PREFIX);
			  ATU_DOUBLE_IMAGE(maType,value_max);
	      }
        }
	  atl_line_dump();
    }
  return ok;
}
#endif /* ATVUSE_DOUBLE*/

#endif /*ATVUSE_FLOAT+ATVUSE_DOUBLE*/

#endif /* RTRT_FLOAT */

#if RTRT_STRING && ATVUSE_STRING
#if ATV_ARRAY_MAX_DIM
atv_flag_type _atv_e_array(
#if !RTRT_KR
	atv_ckt_type checkType,unsigned int typesize ,unsigned int arraysize, atv_string var,atv_id_type id,atv_string valueMin,atv_string valueMax,atv_isLit_type isLiteral)
#else
	(checkType,typesize , arraysize, var, id,valueMin,valueMax,isLiteral)
	atv_ckt_type checkType;
	unsigned int typesize ;
	unsigned int arraysize;
	atv_string var;
	atv_id_type id;
	atv_string valueMin;
	atv_string valueMax;
	atv_isLit_type isLiteral;
#endif
{
	atv_flag_type ok;
	if(typesize == 1) return _atv_e_stringl(checkType, arraysize, var, id, valueMin, valueMax, isLiteral);
	ok=atv_comp_3_str(checkType, arraysize*typesize, valueMin, var, valueMax);
	if(id)
	{
		atv_var_num(id, ok);
        atl_line_add_char(ATV_WORD_PREFIX);
        atl_line_add(RTRT_CONST_STRING( "array" ));
	}
	return ok;
}
#endif /*ATV_ARRAY_MAX_DIM*/
#endif /*RTRT_STRING && ATVUSE_STRING*/

#if USE_ATT
#if !RTRT_KR
void atv_end_loop(void)
#else
void atv_end_loop()
#endif
{ /* MR */
 //  _atl_print_change_source(ATV_SOURCE_GLYPH); /* source Nbre 2 for the GLYPH */

 _atl_print_change_source(_atv_current_source);
 if(_atv_loopError)
 { /* print the result of the previous test */
   _atv_testError |=_atv_loopError;
   _atv_loopError=0;
   _atl_tdf_line_1(_ATO_STYLE_GLYPH_KO,ATV_GLYPH_TXT);
 }
 else
   _atl_tdf_line_1(_ATO_STYLE_GLYPH_OK,ATV_GLYPH_TXT);
   _att_print_change_instance ( ATV_LOOP_INSTANCE );
//   _atl_print_change_source(ATV_SOURCE_DRIVER);

    _atl_tdf_line_1(ATL_TDF_MR ,ATV_LOOP_MSG);
}
#endif /* USE_ATT */

#if !RTRT_KR
void _atv_tc_start(atv_id_type id, const char *name_test, RTRT_U_INT32	key, RTRT_U_INT32	cks)
#else
void _atv_tc_start(id, name_test, key, cks)
atv_id_type        id;
char        *name_test;
RTRT_U_INT32	key;
RTRT_U_INT32	cks;
#endif
{
#if USE_ATC || USE_ATP || USE_ATQ || USE_ATT
 /* if (!_atv_obs_tool_flag) */
  if(_atv_num_current_op ==0)
    {
     /* Obstools dump */
      ATU_SET_SERV_NAME((char *)RTRT_CONST_STRING( "Initialization" ))
     /* _atv_obs_tool_flag = 1; */
#if USE_ATC || USE_ATP || USE_ATQ
      /* Obstools dump */
      _atl_obstools_dump(_ATCPQ_RESET);
#endif
    }
#if USE_ATT
  _atl_highest_source++;
  _atv_current_source=_atl_highest_source;
  _atl_print_source_file(_atv_current_source,key,cks);
  _atl_tdf_line_2(ATL_TDF_ME ,ATV_TEST_MSG,ATV_TEST_INSTANCE);
  _atl_tdf_line_2(ATL_TDF_NI ,ATV_TEST_LINE,ATV_TEST_INSTANCE);
#endif
  ATU_SET_SERV_NAME((char *)name_test)
  _atv_num_current_op=1;
  _atv_num_current_tcid=id;
  _atv_num_current_loop=0;
#endif
  atv_var_num(id, LINETSID);
 // atl_buffer_quoted_string_image(name_test);
  atl_line_dump();
}

#if !RTRT_KR
int _atv_tc_stop(atv_id_type id)
#else
int _atv_tc_stop(id)
atv_id_type        id;
#endif
{
int ret=(int)(_atv_testError & 1);
#if USE_ATT
	  atv_end_loop();
	  _atl_tdf_line_2(ATL_TDF_DI,ATV_LOOP_INSTANCE,ATV_LOOP_MSG);

	  if(_atv_testError & 1)
	  {
		  _atv_testError <<=1; /*set the testSuite error bit and clear the TC error bit*/
	      _atl_tdf_line_1(_ATO_STYLE_GLYPH_KO,ATV_GLYPH_TXT);
	  }
	  else
	   _atl_tdf_line_1(_ATO_STYLE_GLYPH_OK,ATV_GLYPH_TXT);
	   _att_print_change_instance ( ATV_TEST_INSTANCE );

	  _atl_tdf_line_1(ATL_TDF_MR,ATV_TEST_MSG);
	  _atl_tdf_line_2(ATL_TDF_DI,ATV_TEST_INSTANCE,ATV_TEST_MSG);
#endif
#if USE_ATC || USE_ATP || USE_ATQ
  /* Obstools dump */
  _atl_obstools_dump(_ATCPQ_RESET);
#endif /* USE_ATC || USE_ATP || USE_ATQ */
return ret;
}

#if !RTRT_KR
void _atv_end_serie(atv_id_type id,unsigned int level)
#else
void _atv_end_serie(id,level)
    atv_id_type        id;
	unsigned int level
#endif
{
  atv_var_num(id, LINETYPEBREDCRUMB);
  atl_line_inc(unsigned_reverse_large_image_16(level, atl_line_cur));
  atl_line_dump();
}

#if !RTRT_KR
void _atv_new_loop(void)
#else
void _atv_new_loop()
#endif
{
#if USE_ATC || USE_ATP || USE_ATQ || USE_ATT
#if USE_ATT
  if(_atv_num_current_loop)
  {
	atv_end_loop();
    _atl_tdf_line_2(ATL_TDF_ME ,ATV_LOOP_MSG,ATV_LOOP_INSTANCE);
  }
  else
  {
    _atl_tdf_line_2(ATL_TDF_ME ,ATV_LOOP_MSG, ATV_LOOP_INSTANCE);
    _atl_tdf_line_2(ATL_TDF_NI ,ATV_LOOP_LINE,ATV_LOOP_INSTANCE);
  }
#endif
#endif

  _atv_num_current_loop++;
  atv_var_num(_atv_num_current_loop, LINETYPELOOP);

/* mettre le No loop avec le No du test sur la meme ligne
  atv_var_num(_atv_num_current_tcid, LINETSID);
  atl_line_add_char(' ');
  atl_line_inc(unsigned_reverse_image_16(_atv_num_current_loop, atl_line_cur));

*/
  atl_line_dump();

  _atv_array_mode = 0;
  _atv_global_result = 1;
  _atv_block_idx[0] = 0;
}

#if !RTRT_KR
void _atv_ts_start(RTRT_U_INT32	key, RTRT_U_INT32	cks)
#else
void _atv_ts_start(key,cks)
RTRT_U_INT32	key; //key,cks de la TS
RTRT_U_INT32	cks;
#endif
{
#if !RTRT_RAM_CLEAN
  _atv_array_mode = 0;
#if ATVUSE_STUBS
  _atv_stub_num=0;
  _atv_stub_result=0;
  _atv_stub_min=0;
  _atv_stub_max=0;
#endif /* ATVUSE_STUBS */
#if RTRT_STRING && ATVUSE_STRING
#if RTRT_STR_CONCAT_SUPPORTED
  _atv_string_num=0;
#endif
#endif /* RTRT_STRING && ATVUSE_STRING */

#if USE_ATC || USE_ATP || USE_ATQ || USE_ATT
  ATU_SET_SERV_NAME((char *)0)
  ATU_SET_TEST_NAME((char *)0)
  _atv_num_current_tcid =0;
  _atv_num_current_op =0;
  /* _atv_obs_tool_flag =0; */
#if USE_ATT
  _atv_stubCalled=0;
#endif /*USE_ATT*/
#endif /*USE_ATC || USE_ATP || USE_ATQ || USE_ATT*/
#endif /*RTRT_RAM_CLEAN*/

  atl_early_init();
  atl_line_add("I6 "); /* LINETYPENEWTEST */
  atl_line_add_char ( RTRT_QUOT );
#if RTRT_CLOCK != RTRT_NONE
  atl_line_add(RTRT_UNIT_TYPE_NAME);
#endif
  atl_line_add_char ( RTRT_QUOT );
#if RTRT_FLOAT_DUMP
#if ATVUSE_FLOAT
  ATL_LINE_ADD_OPCODE(" F ");
  atl_line_inc(float_image((float)   3.14159265358979323846, atl_line_cur));
#endif /* ATVUSE_FLOAT */
#if ATVUSE_DOUBLE
  ATL_LINE_ADD_OPCODE(" D ");
  atl_line_inc(double_image((double) 3.14159265358979323846, atl_line_cur));
#endif /* ATVUSE_DOUBLE */
#endif /* RTRT_FLOAT_DUMP */
  atl_line_dump();

_atv_testError=0;
#if USE_ATT
_atv_loopError=0;
/* source = instance using ATT for C */
//_atl_highest_source=3; /* 3 first instances are the test driver and stub */
//_atl_print_source_file(ATV_SOURCE_GLYPH,ATV_SOURCE_GLYPH,0);
_atl_print_source_file(ATV_SOURCE_SUITE,key,cks);
_atl_highest_source=ATV_SOURCE_SUITE+1; /* the 2 first instances booked for the stub line */
#endif
}

#if !RTRT_KR
void _atv_ts_stop(void)
#else
void _atv_ts_stop()
#endif
{
#if USE_ATT
  if(_atv_testError)
  { /* print the result of the last test */
     _atl_print_change_source(ATV_SOURCE_SUITE); /* select the first TC source */
     _atl_tdf_line(_ATO_STYLE_CHECK_KO);
     _atl_tdf_line_1( ATL_TDF_NO , ATV_TX_ERROR);
     _att_print_change_instance ( 0 );
  }
#endif
#if USE_ATC || USE_ATP || USE_ATQ || USE_ATT
  /* Obstools dump */
  _atv_num_current_tcid=0;
  _atv_num_current_op=2;
  ATU_SET_SERV_NAME((char *)RTRT_CONST_STRING( "Termination" ))

#if USE_ATC || USE_ATP || USE_ATQ
  /* Obstools dump */
  _atl_obstools_dump(_ATCPQ_RESET);
#endif
#endif
  atl_exit();
}

/* called by the stub itself after parameter and call number checks */
#if ATVUSE_STUBS
#if !RTRT_KR
void _atv_trace_stub( atv_id_type stub_id, int a_status, int call_num)
#else
void _atv_trace_stub( stub_id, a_status, call_num)
  atv_id_type stub_id;
  int a_status;
  unsigned int call_num;
#endif
{
#if USE_ATT

  if (stub_id)
  {
	  _atl_print_change_source(ATV_SOURCE_SUITE);
#if ATT_TIMESTAMP
	  _att_print_time_stamp ( );
#endif
	  _atl_tdf_line_2(ATL_TDF_ME ,ATV_ATT_STUB_NAME(stub_id),ATV_STUB_INSTANCE);
	  if(!_atv_stubCalled)
	  { /* create the line at the first stub only */
		  _atl_tdf_line_2(ATL_TDF_NI ,1,ATV_STUB_INSTANCE);
		  _atv_stubCalled=1;
	  }
	  /* stub check status * /
	  if(a_status)
		  _atl_tdf_line_1(_ATO_STYLE_GLYPH_KO,ATV_TEST_KO);
	  else
		  _atl_tdf_line_1(_ATO_STYLE_GLYPH_OK,ATV_TEST_OK);
	   */
	  _atl_tdf_line_1((a_status?_ATO_STYLE_GLYPH_KO:_ATO_STYLE_GLYPH_OK),ATV_TEST_OK+(a_status&3));

	  _att_print_change_instance ( ATV_STUB_INSTANCE );
	  /* stub return */
	  _atl_tdf_line_1(ATL_TDF_MR ,ATV_ATT_STUB_NAME(stub_id));
  }
#endif /* USE_ATT */
}

#if !RTRT_KR
char _atv_nb_call_stub( atv_id_type stub_id, unsigned int value, unsigned int value_min, char noLimit)
#else
char _atv_nb_call_stub( stub_id, value, value_min, noLimit)
  atv_id_type stub_id;
  unsigned int value;
  unsigned int value_min;
  char noLimit;
#endif
{
  char ok=0;
  if((value == value_min) || ((noLimit) && (value > value_min))) ok=1;
  else { _ATV_SETERROR }
  atv_var_num(stub_id, LINETYPESTUBERROR);
  atl_line_add_char('0'+ok);
  atl_line_add_char(' ');
  atl_line_inc(unsigned_reverse_large_image_16(value, atl_line_cur));
  atl_line_add_char(' ');
  atl_line_inc(unsigned_reverse_large_image_16(value_min, atl_line_cur));
  atl_line_dump();
  return ok;
}

#if !RTRT_KR
void _atv_stub_call_fail(atv_id_type stub_id,unsigned int call_num)
#else
void _atv_stub_call_fail( stub_id, call_num)
  atv_id_type stub_id;
  unsigned int call_num;
#endif
{
	/* provide the tdc id for this stub */
  atv_var_num(stub_id, LINETSID);
  atl_line_add_char(' ');
  atl_line_inc(unsigned_reverse_large_image_16(call_num, atl_line_cur));
  atl_line_dump();
  _ATV_SETERROR
}

void _atv_stub_call_fail_end()
{
  atv_var_num(_atv_num_current_tcid, LINETSID);
  atl_line_dump();
}
#endif /*ATVUSE_STUBS*/

#if RTRT_CLOCK != RTRT_NONE
#if !RTRT_KR
RTRT_STATICFCT _ATV_LARGEST_INT atv_clock(void)
#else
RTRT_STATICFCT _ATV_LARGEST_INT atv_clock()
#endif
{
  RTRT_CLOCK_TYPE now;

  priv_clock(&now);
  return (_ATV_LARGEST_INT) RTRT_CLOCK_TO_UNITS (now);
}
#endif /* RTRT_CLOCK != RTRT_NONE */

#if 0 // unused for now
#if !RTRT_KR
void _atv_check_begin(atv_id_type id)
#else
void _atv_check_begin(id)
atv_id_type id;
#endif
{
  atv_var_num(id, LINETCID);
  atl_line_dump();
}

#if !RTRT_KR
void _atv_ts_code_begin(atv_id_type id)
#else
void _atv_ts_code_begin(id)
atv_id_type id;
#endif
{
  atv_var_num(id, LINETSID);
  atl_line_dump();
}
#endif

#if !RTRT_KR
void _atv_code_begin(atv_id_type id, char blockType)
#else
void _atv_code_begin(id,blockType)
atv_id_type id;
char blockType;
#endif
{
  atv_var_num(id, LINETCID);
  atl_line_add_char(blockType);
//  atl_line_add_char('x');
  atl_line_dump();

#if RTRT_CLOCK != RTRT_NONE
  if(blockType == 'x')
  {
    _atv_start_time = atv_clock();
  }
#endif /* RTRT_CLOCK != RTRT_NONE */
}


#if !RTRT_KR
void _atv_code_end(atv_id_type id)
#else
void _atv_code_end(id)
atv_id_type id;
#endif
{
#if RTRT_CLOCK != RTRT_NONE
  _ATV_LARGEST_INT stop_time;

  stop_time = atv_clock();

  atv_var_num(id, LINETCID);
  atl_line_add_char('x');
  //atl_line_add(RTRT_UNIT_TYPE_FORMAT);
  atl_line_add_char(' ');
  atl_line_inc(integer_reverse_large_image_16((_ATV_LARGEST_INT)(stop_time-_atv_start_time-RTUT_DELAY), atl_line_cur));
#else /* RTRT_CLOCK != RTRT_NONE */
  atv_var_num(id, LINETCID);
  atl_line_add("x -");
#endif /* RTRT_CLOCK != RTRT_NONE */
  atl_line_dump();

  if (( _atv_array_mode != 0) ||(  _atv_global_result > 1) ||(  _atv_global_idx != 0))
    {
      /* ATL_LINE_ADD_OPCODE("W0 Warning: Internal runtime variables modified by code under Test"); */
      ATL_ERROR('0',"Warning: Internal runtime variables modified by code under Test");
      atl_line_dump();
    }

  _atv_array_mode = 0;
  _atv_global_result = 1;

#if ATVUSE_STUBS
  if (_atv_stub_num)
    {
      //edv_chrono_muet_c( 0, 0, 0);
    }
#endif
#if USE_ATT
 _atl_print_change_source(_atv_current_source);
#endif
}

